#include <stdio.h>
#include <stdlib.h>
#define INF_F 99e13
#define MAXN 256
#define INF_V 1024
struct __edge
{
    int to;
    int v;
    union
    {
        float ti;//     
        int l;//  v==0
    };
};

typedef struct __edge edge;

edge nab[MAXN][MAXN];//  
int nn[MAXN];
int ve[MAXN];//            (INF_V)       )
float t[MAXN];//    ...           
int d;
int edge_cmp(const void* a,const void* b)
{
    return ((edge*)a)->v-((edge*)b)->v;//  ...  - 
}
bool been[MAXN];
void dfs(int e,float ti,int v)
{
    int i;
    if(e==d)
    {
        if(t[d]>ti)
            t[d]=ti;
        return;
    }
 //   printf("node %d in time %f\n",e,ti);
    for(i=0;i<nn[e];i++)
    {
        if(been[nab[e][i].to])
            continue;
//        printf("edge to %d with time %f\n",nab[e][i],t[nab[e][i].to]);
        if(nab[e][i].v!=0&&(ti+nab[e][i].ti)< t[nab[e][i].to])
        {
            t[nab[e][i].to]=ti+nab[e][i].ti;
            been[nab[e][i].v]=true;
            dfs(nab[e][i].to,ti+nab[e][i].ti,nab[e][i].v);
            been[nab[e][i].v]=false;
        }
        else if(v>ve[nab[e][i].to])
        {
            ve[nab[e][i].to]=v;
            if(t[nab[e][i].to]>ti+(float)nab[e][i].l/float(v))
                t[nab[e][i].to]=ti+(float)nab[e][i].l/float(v);
            been[nab[e][i].v]=true;
            dfs(nab[e][i].to,ti+(float)nab[e][i].l/(float)v,v);
            been[nab[e][i].v]=false;
        }
    }
}
#define ADD(a,b,c,d)\
{       \
   nab[a][nn[a]].to=b;\
   nab[a][nn[a]].v=c;\
   if(c==0)\
    nab[a][nn[a]++].l=d;\
    else\
    nab[a][nn[a]++].ti=(float)d/(float)c;\
}
int main()
{
   int i,n,m,a,b,c,de;
   scanf("%d%d%d",&n,&m,&d);
   d--;
   for(i=0;i<n;i++)
        ve[i]=INF_V;
   for(i=0;i<m;i++)
    {
        scanf("%d%d%d%d",&a,&b,&c,&de);
        a--;
        b--;
        ADD(a,b,c,de);
        ADD(b,a,c,de);
        if(c==0)
            ve[a]=ve[b]=0;//      
    }
    for(i=0;i<n;i++)
    {
        qsort(nab[i],nn[i],sizeof(edge),edge_cmp);
        t[i]=INF_F;
    }
    t[0]=0;
    been[0]=true;
    dfs(0,0.0f,70);
    //printf("%d ",d);
    printf("%.6f\n",t[d]);
    return 0;
}
