#include <cstdio>
//#include <iostream>
#include <vector>
#include <set>
#define ii pair<int, int>
#define dii pair<double, ii>
using namespace std;

struct e {
  int u,v,l;
};

vector<e> G[160];
int n,m,end;
int inspeed[160];


int main() {
  scanf("%d%d%d", &n,&m,&end);
  for(int i=0;i<m;i++) {
    int u;
    e tmp;
    scanf("%d%d%d%d", &u,&tmp.u,&tmp.v,&tmp.l);
    G[u].push_back(tmp);
    swap(u, tmp.u);
    G[u].push_back(tmp);
  }

//  for(int i=0;i<n;i++) {
//    cout<<i<<":  ";
//    for(int j=0;j<G[i].size();j++) 
//      cout<<"("<<G[i][j].u<<","<<G[i][j].v<<","<<G[i][j].l<<") ";
//    cout<<endl;
//  }

  vector<double> D(n+1, INT_MAX);
  vector<bool> used(n+1, 0);
  D[1] = 0;
  used[1]=true;
  
  set<dii> s;
  s.insert(dii(0, ii(1, 70)));
  inspeed[1] = 70;
  
  while(s.size()) {
    dii tmp = *s.begin();
    s.erase(s.begin());

    double w=tmp.first;
    int u=tmp.second.first, speed=tmp.second.second;
//    printf("%f %d %d\n", w, u, speed);
    
    D[u] = w;
    used[u] = true;
    
    for(int i=0;i<G[u].size();i++) {
      e edge = G[u][i];
//      cout<<"  "<<edge.u<<" "<<edge.v<<" "<<edge.u<<endl;
      if(!used[edge.u]) {
        double newW;
        int sp;
        if(edge.v)
          sp=edge.v;
        else
          sp=speed;
        double time = ((double)edge.l)/((double)sp);
//        cout<<"   "<<time<<endl;
        newW = D[u]+time;
        if(D[edge.u] == INT_MAX) {
          D[edge.u] = newW;
          s.insert(dii(newW, ii(edge.u, sp)));
          inspeed[edge.u] = sp;
        } 
        else if(D[edge.u]>newW) {
          s.erase(s.find(dii(D[edge.u], ii(edge.u, inspeed[edge.u]))));
          inspeed[edge.u] = sp;
          s.insert(dii(newW, ii(edge.u, sp)));
          D[edge.u] = newW;
        }
      }
    }
  }
  printf("%.6f\n", D[end]);
  return 0;
}

