#include <iostream>
#include <vector>
#include <queue>
using namespace std;
int L[256][256];
int V[256][256];
int N,M,D;
vector<pair<int,int> > list;
vector<pair<int,double> > gr[22500];
vector<int> ds;
double dd[22500];
bool used[22500];
bool u[151][512];

struct srav
{
    bool operator () (pair<int,double> &A,pair<int,double> &B) const
    {
        return A.second>B.second;
    }
};

priority_queue<pair<int,double> > dist;

void buildQkGraf()
{
	list.push_back(make_pair(1,70));
	u[1][70]=1;
	for(int i=1;i<=N;i++)
		for(int j=1;j<=N;j++)
			if(V[i][j]!=-1 && !u[i][V[i][j]])
			{
				u[i][V[i][j]]=1;
				list.push_back(make_pair(i,V[i][j]));
				if(i==D) ds.push_back(list.size()-1);
			}
	double tv;
	for(int i=0;i<list.size();i++)
		for(int j=0;j<list.size();j++)
		{
            if(i==j) continue;
            
			if(L[list[i].first][list[j].first]>0 && V[list[i].first][list[j].first]==list[j].second)
			{
                if(V[list[i].first][list[j].first]==0) tv=(double)L[list[i].first][list[j].first]/(double)list[i].second;
                else tv=(double)L[list[i].first][list[j].first]/(double)V[list[i].first][list[j].first];
                gr[i].push_back(make_pair(j,tv));
            }
		}	
}

void dijkstra()
{
    for(int i=0;i<=list.size();i++) dd[i]=1000000;
    int v=0;
    dd[0]=0;
    
    do
    {
        for(int i=0;i<gr[v].size();i++)
        {
            used[v]=1;
            if(dd[gr[v][i].first]>dd[v]+gr[v][i].second)
            {
                dd[gr[v][i].first]=dd[v]+gr[v][i].second;
                dist.push(make_pair(gr[v][i].first,dd[gr[v][i].first]));
            }
        }
        
        while(!dist.empty() && used[dist.top().first]) dist.pop();
        if(dist.empty()) break;
        v=dist.top().first;
    }
    while(!dist.empty());
    
//    for(int i=0;i<list.size();i++) cout<<dd[i]<<" ";    
    double minD=1000000;
    for(int i=0;i<ds.size();i++)
    {
 //       cout<<"?"<<ds[i]<<" ";
        minD=min(minD,dd[ds[i]]);
    }
 //   cout<<":"<<minD<<endl;
    printf("%.6f\n",minD);
}

int main()
{
    
	for(int i=0;i<151;i++)
		for(int j=i;j<151;j++)
			V[i][j]=V[j][i]=-1;
			
	int a,b,c,d;
	cin>>N>>M>>D;
	for(int i=1;i<=M;i++)
	{
		cin>>a>>b>>c>>d;
		L[a][b]=L[b][a]=d;
		V[a][b]=V[b][a]=c;
	}
	
	buildQkGraf();
	
	dijkstra();
}
